<?php
/**
 * Created by PhpStorm.
 * User: migue
 * Date: 02/06/2017
 * Time: 12:06
 */

namespace Oct8ne\Oct8ne\Controller\Frame;

use \Magento\Framework\App\Action\Context;
use \Oct8ne\Oct8ne\Helper\ResponseHelper;
use \Magento\Framework\App\Config\ScopeConfigInterface;
use \Magento\Sales\Model\ResourceModel\Order\CollectionFactory;
use \Oct8ne\Oct8ne\Helper\Oct8neContextHelper;
use \Magento\Framework\Pricing\PriceCurrencyInterface as CurrencyHelper;


class GetOrders extends \Magento\Framework\App\Action\Action
{

    /**
     * @var ProductSummaryHelper|Oct8neModuleInfoHelper
     */
    protected $_oct8necontext;

    protected $_scopeconfig;

    protected $_orderCollectionFactory;

    /**
     * @var Context
     */
    protected $_context;

    protected $_responseHelper;


    protected $_currencyHelper;

    /**
     * Inyeccion de dependencias. Inyectamos lo que nos hace falta
     * GetAdapterInfo constructor.
     * @param Context $context
     * @param ProductSummaryHelper $helper
     */

    public function __construct(Context $context, Oct8neContextHelper $oct8necontext, ResponseHelper $responseHelper, ScopeConfigInterface $scope, CollectionFactory $orderCollectionFactory, CurrencyHelper $currencyHelper)
    {
        $this->_context = $context;
        $this->_oct8necontext = $oct8necontext;
        $this->_responseHelper = $responseHelper;
        $this->_scopeconfig = $scope;
        $this->_orderCollectionFactory = $orderCollectionFactory;
        $this->_currencyHelper = $currencyHelper;


        parent::__construct($context);
    }

    /**
     * Todos los controladores ejecutan el execute despues de la construccion
     * @return \Magento\Framework\View\Result\Page
     */
    public function execute()
    {

        $oct8ne_context = $this->_oct8necontext->getOct8neContext();

        
        $apiToken = $this->_context->getRequest()->getParam("apiToken");
        $customerEmail = $this->_context->getRequest()->getParam("customerEmail");
        $page = $this->_context->getRequest()->getParam("page");
        $pagesize = $this->_context->getRequest()->getParam("pageSize");
        $locale = $this->_context->getRequest()->getParam("locale");
        $currency = $this->_context->getRequest()->getParam("currency");

        $page = isset($page) ? $page : 1;
        $pagesize = isset($pagesize) ? $pagesize : 10;
        

        
        $token = $this->_scopeconfig->getValue("Oct8ne/user/token", \Magento\Store\Model\ScopeInterface::SCOPE_STORE);

        if($token != $apiToken) return $this->_responseHelper->buildResponse(array()); 


        $ordersCollection = $this->_orderCollectionFactory->create();   
        $ordersCollection->addAttributeToSelect('*');
        $ordersCollection->addFieldToFilter('customer_email',$customerEmail);
        $ordersCollection->setPageSize($pagesize);
        $ordersCollection->setCurPage($page);


        $data = array();
        
        foreach($ordersCollection as $order) {

            $currencyOrder = "";
            $total = strval($this->_currencyHelper->convertAndRound($order->getGrandTotal(), NULL,$currency, 2));
    
            if($oct8ne_context["context_currency"] != $currency) {

                $currencyOrder = $currency;
            } else {
                $currencyOrder = $oct8ne_context["context_currency"];
                $total = $order->getGrandTotal();
            }

            $aux = array(
                "date" => $order->getCreatedAt(),
                //"reference" => $order->getEntityId(),
                "reference" => $order->getIncrementId(),
                "total" => $total,
                "currency" => $currencyOrder,    
                "labelState" => $order->getStatusLabel(),
                "deliveryDate" => ""
            );
            $data[] = $aux;
        }

    
        return $this->_responseHelper->buildResponse($data);

    }
}